# https://www.outsidethebox.ms/21949/
# https://learn.microsoft.com/en-us/previous-versions/windows/it-pro/windows-10/security/threat-protection/auditing/event-4688
$myevents = @()
$events = Get-WinEvent -ErrorAction 0 -FilterHashTable @{
  LogName='Security'
  ProviderName='Microsoft-Windows-Security-Auditing'
  ID='4688'
  #Events for the past 5 hours only
  StartTime=(Get-Date).AddMinutes(-300)
  #PowerShell Core only, speeds up filtering https://bit.ly/3UPwiks
  NewProcessName='C:\Windows\explorer.exe'
} 
foreach ($e in $events) {
    $e = [xml]$e.ToXml()
     $eventdetails = New-Object -Type Psobject -Property @{
      "EventTime" = $e.Event.System.TimeCreated.SystemTime
      "NewProcessID" = [int]($e.SelectSingleNode("//*[@Name='NewProcessId']")."#text")
      "NewProcessName" = $e.SelectSingleNode("//*[@Name='NewProcessName']")."#text"
      "ParentProcessName" = $e.SelectSingleNode("//*[@Name='ParentProcessName']")."#text"
      "ParentProcessID" = [int]($e.SelectSingleNode("//*[@Name='ProcessId']")."#text")
      "TokenElevationType" = $e.SelectSingleNode("//*[@Name='TokenElevationType']")."#text"
      "MandatoryLabel" = $e.SelectSingleNode("//*[@Name='MandatoryLabel']")."#text"
    }
    $myevents += $eventdetails
}
$myevents | fl EventTime,NewProcessID,NewProcessName,ParentProcessID,ParentProcessName,TokenElevationType,MandatoryLabel #| Out-File -Append C:\temp\proc.txt
