# https://www.outsidethebox.ms/21949/
$myevents = @()
$events = Get-WinEvent -ErrorAction 0 -FilterHashTable @{
  LogName='Security'
  ProviderName='Microsoft-Windows-Security-Auditing'
  ID='4657'
  #Events for the past 5 days only
  #StartTime=(Get-Date).AddHours(-120)
  #PowerShell Core only, speeds up filtering
  #ObjectValueName='System.IsPinnedToNameSpaceTree'
} 
foreach ($e in $events) {
  $e = [xml]$e.ToXml()
    $eventdetails = New-Object -Type Psobject -Property @{
      "ObjectName" = $e.SelectSingleNode("//*[@Name='ObjectName']")."#text"
      "ObjectValueName" = $e.SelectSingleNode("//*[@Name='ObjectValueName']")."#text"
      "OldValue" = $e.SelectSingleNode("//*[@Name='OldValue']")."#text"
      "NewValue" = $e.SelectSingleNode("//*[@Name='NewValue']")."#text"
      "ProcessName" = $e.SelectSingleNode("//*[@Name='ProcessName']")."#text"
      "SubjectUserName" = $e.SelectSingleNode("//*[@Name='SubjectUserName']")."#text"
      "SubjectUserSid" = $e.SelectSingleNode("//*[@Name='SubjectUserSid']")."#text"
      "EventTime" = $e.Event.System.TimeCreated.SystemTime
    }
  $myevents += $eventdetails
}
$myevents | fl Test,EventTime,SubjectUserName,SubjectUserSid,ObjectName,ObjectValueName,NewValue,OldValue,ProcessName
